local array = include( "modules/array" )
local util = include( "modules/util" )
local cdefs = include( "client_defs" )
local simdefs = include( "sim/simdefs" )
local simquery = include( "sim/simquery" )
local inventory = include( "sim/inventory" )
local unitdefs = include( "sim/unitdefs" )
local mission_util = include( "sim/missions/mission_util" )

---------------------------------------------------------------------------------------------
-- Local helpers

local function isConsolePred( u )
	return u:getTraits().mainframe_console and not u:getTraits().console_incident
end

local function hijackConsole( script, sim )
	local consoleUnit = simquery.findUnit( sim:getAllUnits(), isConsolePred )
	if consoleUnit == nil then
		log:write( "alpha_console : no valid console" )
		return
	end

	log:write( "alpha_console : unit [%d] at <%d, %d>", consoleUnit:getID(), consoleUnit:getLocation() )
	consoleUnit:getTraits().console_incident = true
	local _, triggerData = script:waitFor( mission_util.PC_HIJACKED( consoleUnit:getID() ))
 	local unit = triggerData.sourceUnit

	local title = "CONSOLE"
	local txt = "Part of an decrypted email is on-screen: THESE THINGS WERE MADE TO STAY ON EARTH. YOU HAVE PUT NOT ONLY YOURSELF IN DAN-- the decryption ends abruptly."
	local options =
	{ 
		"Close",
	}
	mission_util.showDialog( sim, title, txt, options )
end

---------------------------------------------------------------------------------------------
-- Begin!

local incident = class()

function incident:init( scriptMgr, sim )
	self.scriptMgr = scriptMgr
	scriptMgr:addHook( "ALPHA_CONSOLE", hijackConsole, false )
end

return incident