local array = include( "modules/array" )
local util = include( "modules/util" )
local mathutil = include( "modules/mathutil" )
local cdefs = include( "client_defs" )
local simdefs = include( "sim/simdefs" )
local simquery = include( "sim/simquery" )
local inventory = include( "sim/inventory" )
local unitdefs = include( "sim/unitdefs" )
local usable_item = include( "sim/units/usable_item" )
local mission_util = include( "sim/missions/mission_util" )

local INCIDENT_NAME = "Covert Dialog"

local incident = class(mission_util.alpha_talk)

function incident:talkHook( script, sim, agent )
	local _, triggerData = script:waitFor( mission_util.PC_TALKED_TO( agent:getID() ))
	local unit = triggerData.sourceUnit


	local profileBuild = agent.profile_build	
	local profileAnim = agent.profile_anim

	triggerData.abort = true	

	local txt = "I've got major heat on me, time to evac. I won't be needing this."
	local option = mission_util.showDialog( sim, INCIDENT_NAME, txt, nil, { enemyProfile = {build = profileBuild, anim = profileAnim, color={r=0,g=0,b=0}} } )	 

	mission_util.giftItem( sim, unit, "passcard")	
	sim:warpUnit( agent, nil )
	sim:despawnUnit( agent )
	local params = {}
	sim:dispatchEvent( simdefs.EV_UNIT_ADD_FX, { unit = cell, kanim = "fx/agent_cloak_fx", symbol = "effect", anim="in", above=true, params=params} )
	
end

return incident