---------------------------------------------------------------------
-- Invisible Inc. Mod.

local util = include( "modules/util" )
local commondefs = include( "sim/unitdefs/commondefs" )
local simdefs = include("sim/simdefs")
local speechdefs = include("sim/speechdefs")

local DEFAULT_DRONE = commondefs.DEFAULT_DRONE
local SOUNDS = commondefs.SOUNDS

local KPC_SOUNDS =
{
    bio = "",
    escapeVo = "",
	speech="SpySociety/Agents/dialogue_player",  
	step = simdefs.SOUNDPATH_FOOTSTEP_MALE_HARDWOOD_NORMAL, 
	stealthStep = simdefs.SOUNDPATH_FOOTSTEP_MALE_HARDWOOD_SOFT,

	wallcover = "SpySociety/Movement/foley_cyborg/wallcover", 
	crouchcover = "SpySociety/Movement/foley_cyborg/crouchcover",
	fall = "SpySociety/Movement/foley_cyborg/fall",	
	land = "SpySociety/Movement/deathfall_agent_hardwood",
	land_frame = 35,	
	getup = "SpySociety/Movement/foley_cyborg/getup",
	grab = "SpySociety/Movement/foley_cyborg/grab_guard",
	pin = "SpySociety/Movement/foley_cyborg/pin_guard",
	pinned = "SpySociety/Movement/foley_cyborg/pinned",
	peek_fwd = "SpySociety/Movement/foley_cyborg/peek_forward",	
	peek_bwd = "SpySociety/Movement/foley_cyborg/peek_back",
	move = "SpySociety/Movement/foley_cyborg/move",						
	hit = "SpySociety/HitResponse/hitby_ballistic_cyborg",
}

local MIST_SOUNDS =
{
    bio = "",
    escapeVo = "",
	speech="SpySociety/Agents/dialogue_player",  
	step = simdefs.SOUNDPATH_FOOTSTEP_FEMALE_HARDWOOD_NORMAL, 
	stealthStep = simdefs.SOUNDPATH_FOOTSTEP_FEMALE_HARDWOOD_SOFT, 

	wallcover = "SpySociety/Movement/foley_trench/wallcover",
	crouchcover = "SpySociety/Movement/foley_trench/crouchcover",
	fall = "SpySociety/Movement/foley_trench/fall",
	land = "SpySociety/Movement/deathfall_agent_hardwood",
	land_frame = 16,						
	getup = "SpySociety/Movement/foley_trench/getup",	
	grab = "SpySociety/Movement/foley_trench/grab_guard",
	pin = "SpySociety/Movement/foley_trench/pin_guard",
	pinned = "SpySociety/Movement/foley_trench/pinned",
	peek_fwd = "SpySociety/Movement/foley_trench/peek_forward",	
	peek_bwd = "SpySociety/Movement/foley_trench/peek_back",	
	move = "SpySociety/Movement/foley_trench/move",
	hit = "SpySociety/HitResponse/hitby_ballistic_flesh",
}

local GHUFF_SOUNDS =
{
    bio = "",
    escapeVo = "",
    speech="SpySociety/Agents/dialogue_player",  
    step = simdefs.SOUNDPATH_FOOTSTEP_MALE_HARDWOOD_NORMAL, 
    stealthStep = simdefs.SOUNDPATH_FOOTSTEP_MALE_HARDWOOD_SOFT, 
					
    wallcover = "SpySociety/Movement/foley_suit/wallcover",
    crouchcover = "SpySociety/Movement/foley_suit/crouchcover",
    fall = "SpySociety/Movement/foley_suit/fall",	
    fall_knee = "SpySociety/Movement/bodyfall_agent_knee_hardwood",
    fall_kneeframe = 9,
    fall_hand = "SpySociety/Movement/bodyfall_agent_hand_hardwood",
    fall_handframe = 20,
    land = "SpySociety/Movement/deathfall_agent_hardwood",
    land_frame = 35,						
    getup = "SpySociety/Movement/foley_suit/getup",	
    grab = "SpySociety/Movement/foley_suit/grab_guard",	
    pin = "SpySociety/Movement/foley_suit/pin_guard",
    pinned = "SpySociety/Movement/foley_suit/pinned",
    peek_fwd = "SpySociety/Movement/foley_suit/peek_forward",	
    peek_bwd = "SpySociety/Movement/foley_suit/peek_back",	
    move = "SpySociety/Movement/foley_suit/move",	
    hit = "SpySociety/HitResponse/hitby_ballistic_flesh",
}

local CYBERNETICIST_SOUNDS =
{
    bio = "",
    escapeVo = "",
	speech="SpySociety/Agents/dialogue_player",  
	step = simdefs.SOUNDPATH_FOOTSTEP_FEMALE_HARDWOOD_NORMAL, 
	stealthStep = simdefs.SOUNDPATH_FOOTSTEP_FEMALE_HARDWOOD_SOFT,

	wallcover = "SpySociety/Movement/foley_suit/wallcover", 
	crouchcover = "SpySociety/Movement/foley_suit/crouchcover",
	fall = "SpySociety/Movement/foley_suit/fall",
	land = "SpySociety/Movement/deathfall_agent_hardwood",
	land_frame = 16,						
	getup = "SpySociety/Movement/foley_suit/getup",
	grab = "SpySociety/Movement/foley_suit/grab_guard",
	pin = "SpySociety/Movement/foley_suit/pin_guard",
	pinned = "SpySociety/Movement/foley_suit/pinned",
	peek_fwd = "SpySociety/Movement/foley_suit/peek_forward",	
	peek_bwd = "SpySociety/Movement/foley_suit/peek_back",
	move = "SpySociety/Movement/foley_suit/move",		
	hit = "SpySociety/HitResponse/hitby_ballistic_flesh",		
}

local agent_templates =
{
	mod_01_pedler =
	{
		type = "simunit",
      		agentID = "mod_01_pedler",
		name = STRINGS.AMRE.AGENTS.KPC.NAME,
		fullname = STRINGS.AMRE.AGENTS.KPC.FULLNAME,
		codename = STRINGS.AMRE.AGENTS.KPC.FULLNAME,
		loadout = {"cybertech_01_a",},
		loadoutName = STRINGS.AMRE.AGENTS.KPC.LOADOUT_1,
		file = STRINGS.AMRE.AGENTS.KPC.FILE,
		yearsOfService = STRINGS.AMRE.AGENTS.KPC.YEARS_OF_SERVICE,
		age = STRINGS.AMRE.AGENTS.KPC.AGE,
		homeTown =  STRINGS.AMRE.AGENTS.KPC.HOMETOWN,
		gender = "male",
		class = "Engineer",
		toolTip = STRINGS.AMRE.AGENTS.KPC.TOOLTIP,
		onWorldTooltip = commondefs.onAgentTooltip,
		profile_icon_36x36= "gui/profile_icons/tech_36.png",
		profile_icon_64x64= "gui/profile_icons/pedler_64x64.png",
		splash_image = "gui/agents/pedler_1024.png",
		profile_anim = "portraits/robot_face",	
		team_select_img = { 
					"gui/agents/team_select_1_pedler.png",
		},
		kanim = "kanim_cyborg_engineer",
		hireText =  STRINGS.AMRE.AGENTS.KPC.RESCUED,
		traits = util.extend( commondefs.DEFAULT_AGENT_TRAITS ) { mp=8, mpMax = 8, inventoryMaxSize = 4, hits = "spark", augmentMaxCapacity = 8, canKO = false, dashSoundRange = 8, isMetal = true, dragCostMod = 0.5,  },
		skills = util.extend( commondefs.DEFAULT_AGENT_SKILLS ) {}, 
		startingSkills = { },
		abilities = util.tconcat( {  "sprint", "breakDoor_2",  }, commondefs.DEFAULT_AGENT_ABILITIES ),
		children = {},
		sounds = KPC_SOUNDS,
		speech = STRINGS.AMRE.AGENTS.KPC.BANTER,
		blurb = STRINGS.AMRE.AGENTS.KPC.BIO,
		upgrades = { "augment_kpc_pistons", "item_kpctech_scangrenade", "item_kpc_tazer", },
		logs = {},
	},	

	mod_02_mist =
	{
		type = "simunit",
   		agentID = "mod_02_mist",
		name = STRINGS.AMRE.AGENTS.MIST.NAME,
		file =  STRINGS.AMRE.AGENTS.MIST.FILE,
		fullname = STRINGS.AMRE.AGENTS.MIST.FULLNAME,
		loadoutName = STRINGS.UI.ON_FILE,
		yearsOfService = STRINGS.AMRE.AGENTS.MIST.YEARS_OF_SERVICE,
		age = STRINGS.AMRE.AGENTS.MIST.AGE,
		homeTown = STRINGS.AMRE.AGENTS.MIST.HOMETOWN,
		gender = "female",
		class = "Stealth",
		toolTip = STRINGS.AMRE.AGENTS.MIST.TOOLTIP,
		onWorldTooltip = commondefs.onAgentTooltip,
		profile_icon_36x36= "gui/profile_icons/mist_36.png",
		profile_icon_64x64= "gui/profile_icons/mist_64x64.png",
		splash_image = "gui/agents/mist_1024.png",
		team_select_img = {
			"gui/agents/team_select_1_mist.png",
		},

		profile_anim = "portraits/portrait_animation_template",
		profile_build = "portraits/mist_build",
		kanim = "kanim_agent_mist_01",
		hireText = STRINGS.AMRE.AGENTS.MIST.RESCUED,
		traits = util.extend( commondefs.DEFAULT_AGENT_TRAITS ) { mp=8, mpMax =8, },
		skills = util.extend( commondefs.DEFAULT_AGENT_SKILLS ) {}, 
		--startingSkills = { anarchy = 2 },
		startingSkills = { },
		abilities = util.tconcat( { "sprint", }, commondefs.DEFAULT_AGENT_ABILITIES ), 
		children = { }, -- Dont add items here, add them to the upgrades table in createDefaultAgency()
		sounds = MIST_SOUNDS,
		speech = STRINGS.AMRE.AGENTS.MIST.BANTER,
		blurb = STRINGS.AMRE.AGENTS.MIST.BIO,
		upgrades = { "augment_mod_mist", "item_power_tazer_extra_weak", "item_hologrenade", },
	},	

	mod_03_ghuff =
	{
		type = "simunit",
     		agentID = "mod_03_ghuff",
		name = STRINGS.AMRE.AGENTS.GHUFF.NAME,
		file = STRINGS.AMRE.AGENTS.GHUFF.FILE,
		fullname = STRINGS.AMRE.AGENTS.GHUFF.FULLNAME,
		loadoutName = STRINGS.UI.ON_FILE,
		yearsOfService = STRINGS.AMRE.AGENTS.GHUFF.YEARS_OF_SERVICE,
		age = STRINGS.AMRE.AGENTS.GHUFF.AGE,
		homeTown = STRINGS.AMRE.AGENTS.GHUFF.HOMETOWN,
		gender = "male",

		class = "Stealth",
		toolTip = STRINGS.AMRE.AGENTS.GHUFF.TOOLTIP,
		onWorldTooltip = commondefs.onAgentTooltip,
		profile_icon_36x36= "gui/profile_icons/ghuff_36.png",
		profile_icon_64x64= "gui/profile_icons/ghuff_64x64.png",		
		splash_image = "gui/agents/ghuff_1024.png",
		team_select_img = {
			"gui/agents/team_select_1_ghuff.png",
		},		
			
		profile_anim = "portraits/portrait_animation_template",
		profile_build = "portraits/ghuff_build",
		kanim = "kanim_agent_ghuff",
		hireText = STRINGS.AMRE.AGENTS.GHUFF.RESCUED,
		traits = util.extend( commondefs.DEFAULT_AGENT_TRAITS ) { mp=8, mpMax = 8, },
		skills = util.extend( commondefs.DEFAULT_AGENT_SKILLS ) {},
		startingSkills = { },
		abilities = util.tconcat( {  "sprint" }, commondefs.DEFAULT_AGENT_ABILITIES ),
		children = {}, -- Dont add items here, add them to the upgrades table in createDefaultAgency()
		sounds = GHUFF_SOUNDS,
		speech = STRINGS.AMRE.AGENTS.GHUFF.BANTER,
		blurb = STRINGS.AMRE.AGENTS.GHUFF.BIO,
		upgrades = { "augment_ghuff_pda", "item_tazer", "item_decoy", },	
	},	

	mod_04_n_umi =
	{
		type = "simunit",
      		agentID = "mod_04_n_umi",
		name = STRINGS.AMRE.AGENTS.NU.NAME,
		file = STRINGS.AMRE.AGENTS.NU.FILE,
		fullname = STRINGS.AMRE.AGENTS.NU.FULLNAME,
		loadoutName = STRINGS.UI.ON_FILE,
		yearsOfService = STRINGS.AMRE.AGENTS.NU.YEARS_OF_SERVICE,
		age = STRINGS.AMRE.AGENTS.NU.AGE,
		homeTown = STRINGS.AMRE.AGENTS.NU.HOMETOWN,
		gender = "female",
		class = "Engineer",
		toolTip = STRINGS.AMRE.AGENTS.NU.TOOLTIP,
		onWorldTooltip = commondefs.onAgentTooltip,
		profile_icon_36x36= "gui/profile_icons/lady_nu_36.png",
		profile_icon_64x64= "gui/profile_icons/nu_64x64.png",
		splash_image = "gui/agents/nu_1024.png",

		team_select_img = {
			"gui/agents/team_select_1_nu.png",
		},

		profile_anim = "portraits/lady_sharpshooter_face",
		profile_build = "portraits/nu_lady_face",
		kanim = "kanim_lady_cyberneticist",
		hireText = STRINGS.AMRE.AGENTS.NU.RESCUED,
	--	centralHireSpeech = SCRIPTS.INGAME.CENTRAL_AGENT_ESCAPE_INTERNATIONALE,
		traits = util.extend( commondefs.DEFAULT_AGENT_TRAITS ) { mp=8, mpMax = 8 },
		skills = util.extend( commondefs.DEFAULT_AGENT_SKILLS ) {}, 
		--startingSkills = { hacking = 2},
		startingSkills = { },
		abilities = util.tconcat( {  "sprint" }, commondefs.DEFAULT_AGENT_ABILITIES ),
		children = {}, -- Dont add items here, add them to the upgrades table in createDefaultAgency()
		sounds = CYBERNETICIST_SOUNDS,
		speech = STRINGS.AMRE.AGENTS.NU.BANTER,
		blurb = STRINGS.AMRE.AGENTS.NU.BIO,
		upgrades = { "augment_spider_ctrl", "item_tazer", "item_canned_spider" },
	},	

}	

return agent_templates