----------------------------------------------------------------
-- Copyright (c) 2012 Klei Entertainment Inc.
-- All Rights Reserved.
-- SPY SOCIETY.
----------------------------------------------------------------

local cdefs = include( "client_defs" )
local util = include( "client_util" )
local commondefs = include( "sim/unitdefs/commondefs" )
local commonanims = include("common_anims")


local AGENT_ANIMS = commondefs.AGENT_ANIMS
local GUARD_ANIMS = commondefs.GUARD_ANIMS
local HOSTAGE_ANIMS = commondefs.HOSTAGE_ANIMS
local DRONE_ANIMS = commondefs.DRONE_ANIMS
local FLOAT_DRONE_ANIMS = commondefs.FLOAT_DRONE_ANIMS
local FLOAT_DRONE_TANK_ANIMS = commondefs.FLOAT_DRONE_TANK_ANIMS
local Layer = commondefs.Layer
local BoundType = commondefs.BoundType

-------------------------------------------------------------------
-- Data for anim definitions.

local animdefs =
{

	kanim_stealth_male_a =
	{
		wireframe =
		{
			"data/anims/characters/agents/overlay_agent_deckard.abld",
		},
		build = 
		{ 
			"data/anims/characters/agents/agent_deckard2.abld",
			"data/anims/characters/anims_male/shared_hits_01.abld",	
			"data/anims/characters/anims_male/shared_attacks_a_01.abld",	
			"data/anims/characters/anims_male/stealth_basic_a_04.abld",				
		},
		grp_build = 
		{
			"data/anims/characters/agents/grp_agent_deckard2.abld",
		},
		grp_anims = commonanims.male.grp_anims,

		anims = commonanims.male.default_anims_unarmed,
		anims_1h = commonanims.male.default_anims_1h,
		anims_2h = commonanims.male.default_anims_2h,
		animMap = AGENT_ANIMS,

		symbol = "character",
		anim = "idle",
		shouldFlip = true,
		scale = 0.25,
		layer = Layer.Unit,
		boundType = BoundType.Character,
		boundTypeOverrides = {			
			{anim="idle_ko" ,boundType= BoundType.CharacterFloor},
			{anim="dead" ,boundType= BoundType.CharacterFloor},
		},
		peekBranchSet = 1,
	},

	publicterminal_glasswall1 =
	{
		build = { "data/anims/Unique_publicterminal/publicterminal_glasswall1.abld", },
		anims = { "data/anims/Unique_publicterminal/publicterminal_glasswall1.adef", },
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Wall,
	},	

	kanim_hall_2x1_sculpt_4=
	{
		build = { "data/anims/FTM_hall/hall_object_2x1sculpt1.abld", "data/anims/general/mf_coverpieces_1x2.abld" },
		anims = { "data/anims/FTM_hall/hall_object_2x1sculpt1.adef", "data/anims/general/mf_coverpieces_1x2.adef" },
		symbol = "character",
		scale = 0.25,
		layer = Layer.Object,
		boundType = BoundType.bound_2x1_med_med,
		filterSymbols = {{symbol="icon",filter="default"}},
	},	

	ftm_hall_couch1 =
	{
		build = { "data/anims/FTM_hall/hall_object_2x1couch1.abld", "data/anims/general/mf_coverpieces_1x2.abld" },
		anims = { "data/anims/FTM_hall/hall_object_2x1couch1.adef", "data/anims/general/mf_coverpieces_1x2.adef"  },
		symbol = "character",
		scale = 0.25,
		layer = Layer.Object,
		boundType = BoundType.bound_2x1_med_med,
		filterSymbols = {{symbol="icon",filter="default"},{symbol="light",filter="default"}},
	},

	ftm_hall_bookshelf =
	{
		build = { "data/anims/FTM_hall/ftm_hall_object_2x1bookshelf.abld", "data/anims/general/mf_coverpieces_1x2.abld" },
		anims = { "data/anims/FTM_hall/ftm_hall_object_2x1bookshelf.adef", "data/anims/general/mf_coverpieces_1x2.adef" },
		symbol = "character",
		scale = 0.25,
		layer = Layer.Object,
		boundType = BoundType.bound_2x1_med_med,
		filterSymbols = {{symbol="icon",filter="default"},{symbol="light",filter="default"}},
	},

	ftm_office_2x1_coffee_table=
	{
		build = { "data/anims/FTM_office/ftm_office_object_2x1coffeetable.abld", "data/anims/general/mf_coverpieces_1x2.abld" },
		anims = { "data/anims/FTM_office/ftm_office_object_2x1coffeetable.adef", "data/anims/general/mf_coverpieces_1x2.adef" },
		symbol = "character",
		scale = 0.25,
		layer = Layer.Object,
		boundType = BoundType.bound_2x1_med_med,
		filterSymbols = {{symbol="icon",filter="default"}},
	},	

	ftm_office_object_2x2ldesk3_items1=
	{
		build = { "data/anims/FTM_office/ftm_office_object_2x2ldesk3_items1.abld", "data/anims/general/mf_coverpieces_2x2.abld" },
		anims = { "data/anims/FTM_office/ftm_office_object_2x2ldesk3_items1.adef", "data/anims/general/mf_coverpieces_2x2.adef" },
		symbol = "character",
		scale = 0.25,
		layer = Layer.Object,
		boundType = BoundType.bound_2x2,
		filterSymbols = {{symbol="icon",filter="default"},{symbol="light",filter="default"}},
	},

	ftm_office_decor_wallmap1 =
	{
		build = { "data/anims/FTM_office/ftm_office_decor_wallmap1.abld" },
		anims = { "data/anims/FTM_office/ftm_office_decor_wallmap1.adef" },
		symbol = "character",
		scale = 0.25,
		boundType = BoundType.Wall2,
	},

	decor_ftm_office_object_2x1ftmbanner1=
	{
		build = { "data/anims/FTM_office/ftm_office_object_2x1ftmbanner1.abld", },
		anims = { "data/anims/FTM_office/ftm_office_object_2x1ftmbanner1.adef", },
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Wall2,
	},



	decor_KO_hall_flooring_doormat1 =
	{
		build = { "data/anims/KO_Hall/ko_hall_flooring_1x1doormat1.abld"},
		anims = { "data/anims/KO_Hall/ko_hall_flooring_1x1doormat1.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_1x1,
		setlayer = "floor",
	},

	decor_KO_hall_flooring_rug1 =
	{
		build = { "data/anims/KO_Hall/ko_hall_flooring_1x1rug1.abld"},
		anims = { "data/anims/KO_Hall/ko_hall_flooring_1x1rug1.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x3,
		setlayer = "floor",
	},

	decor_KO_office_flooring_rug2 =
	{
		build = { "data/anims/KO_office/ko_office_flooring_1x1rug2.abld"},
		anims = { "data/anims/KO_office/ko_office_flooring_1x1rug2.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_4x4,
		setlayer = "floor",
	},

	decor_KO_office_flooring_rug4 =
	{
		build = { "data/anims/KO_office/ko_office_flooring_1x1rug4.abld"},
		anims = { "data/anims/KO_office/ko_office_flooring_1x1rug4.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_4x3,
		setlayer = "floor",
	},

	decor_ko_barracks_flooring_1x1caution1 =
	{
		build = { "data/anims/KO_Barracks/ko_barracks_flooring_1x1caution1.abld"},
		anims = { "data/anims/KO_Barracks/ko_barracks_flooring_1x1caution1.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_4x3,
		setlayer = "floor",
	},

	decor_ko_barracks_flooring_1x1panel6 =
	{
		build = { "data/anims/KO_Barracks/ko_barracks_flooring_1x1panel6.abld"},
		anims = { "data/anims/KO_Barracks/ko_barracks_flooring_1x1panel6.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x2,
		setlayer = "floor",
	},

	decor_KO_lab_flooring_panel3off =
	{
		build = { "data/anims/KO_lab/ko_lab_flooring_1x1panel3off.abld"},
		anims = { "data/anims/KO_lab/ko_lab_flooring_1x1panel3off.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_4x3,
		setlayer = "floor",
	},		

	decor_KO_lab_flooring_panel7on =
	{
		build = { "data/anims/KO_lab/ko_lab_flooring_1x1panel7on.abld"},
		anims = { "data/anims/KO_lab/ko_lab_flooring_1x1panel7on.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x2,
		setlayer = "floor",
	},

	decor_ko_barracks_flooring_1x1panel6 =
	{
		build = { "data/anims/KO_Barracks/ko_barracks_flooring_1x1panel6.abld"},
		anims = { "data/anims/KO_Barracks/ko_barracks_flooring_1x1panel6.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x2,
		setlayer = "floor",
	},

	decor_ko_barracks_flooring_1x1wood2 =
	{
		build = { "data/anims/KO_Barracks/ko_barracks_flooring_1x1wood2.abld"},
		anims = { "data/anims/KO_Barracks/ko_barracks_flooring_1x1wood2.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x2,
		setlayer = "floor",
	},

	decor_ko_barracks_flooring_1x1wood3 =
	{
		build = { "data/anims/KO_Barracks/ko_barracks_flooring_1x1wood3.abld"},
		anims = { "data/anims/KO_Barracks/ko_barracks_flooring_1x1wood3.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x2,
		setlayer = "floor",
	},

	decor_ftm_lab_flooring_1x1alt3=
	{
		build = { "data/anims/FTM_lab/ftm_lab_flooring_1x1_alt3.abld"},
		anims = { "data/anims/FTM_lab/ftm_lab_flooring_1x1_alt3.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x2,
		setlayer = "floor",
	},

	decor_ftm_lab_flooring_1x1panel3=
	{
		build = { "data/anims/FTM_lab/ftm_lab_flooring_1x1_panel3.abld"},
		anims = { "data/anims/FTM_lab/ftm_lab_flooring_1x1_panel3.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x2,
		setlayer = "floor",
	},

	decor_plastek_lab_flooring_1x1light3 =
	{
		build = { "data/anims/Plastek_Lab/plastek_lab_flooring_1x1light3.abld"},
		anims = { "data/anims/Plastek_Lab/plastek_lab_flooring_1x1light3.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x2,
		setlayer = "floor",
	},

	decor_plastek_office_flooring_1x1rug4 =
	{
		build = { "data/anims/Plastek_office/plastek_office_flooring_1x1rug4.abld"},
		anims = { "data/anims/Plastek_office/plastek_office_flooring_1x1rug4.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_4x3,
		setlayer = "floor",
	},

	decor_plastek_psilab_flooring_1x1alt2 =
	{
		build = { "data/anims/Plastek_psilab/plastek_psilab_flooring_1x1alt2.abld"},
		anims = { "data/anims/Plastek_psilab/plastek_psilab_flooring_1x1alt2.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_1x2,
		setlayer = "floor",
	},

		decor_plastek_psilab_flooring_1x1main1 =
	{
		build = { "data/anims/Plastek_psilab/plastek_psilab_flooring_1x1main1.abld"},
		anims = { "data/anims/Plastek_psilab/plastek_psilab_flooring_1x1main1.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_1x2,
		setlayer = "floor",
	},

	decor_Seikaku_lab_flooring_light3 =
	{
		build = { "data/anims/Seikaku_lab/seikaku_lab_flooring_1x1light3.abld"},
		anims = { "data/anims/Seikaku_lab/seikaku_lab_flooring_1x1light3.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x2,
		setlayer = "floor",
	},

	decor_Seikaku_robobay_flooring_light3 =
	{
		build = { "data/anims/Seikaku_robobay/seikaku_robobay_flooring_1x1light3.abld"},
		anims = { "data/anims/Seikaku_robobay/seikaku_robobay_flooring_1x1light3.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x2,
		setlayer = "floor",
	},

	decor_Seikaku_office_flooring1off_alt1 =
	{
		build = { "data/anims/Seikaku_office/seikaku_office_flooring1off_1x1alt1.abld"},
		anims = { "data/anims/Seikaku_office/seikaku_office_flooring1off_1x1alt1.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x2,
		setlayer = "floor",
	},

	decor_Seikaku_office_flooring1off_alt2 =
	{
		build = { "data/anims/Seikaku_office/seikaku_office_flooring1off_1x1alt2.abld"},
		anims = { "data/anims/Seikaku_office/seikaku_office_flooring1off_1x1alt2.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x2,
		setlayer = "floor",
	},

	decor_Seikaku_office_flooring1off_tatami2 =
	{
		build = { "data/anims/Seikaku_office/seikaku_office_flooring1off_1x1tatami2.abld"},
		anims = { "data/anims/Seikaku_office/seikaku_office_flooring1off_1x1tatami2.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_4x3,
		setlayer = "floor",
	},

	decor_Seikaku_office_flooring1on_alt1 =
	{
		build = { "data/anims/Seikaku_office/seikaku_office_flooring1on_1x1alt1.abld"},
		anims = { "data/anims/Seikaku_office/seikaku_office_flooring1on_1x1alt1.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x2,
		setlayer = "floor",
	},

	decor_Seikaku_office_flooring1on_alt2 =
	{
		build = { "data/anims/Seikaku_office/seikaku_office_flooring1on_1x1alt2.abld"},
		anims = { "data/anims/Seikaku_office/seikaku_office_flooring1on_1x1alt2.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x2,
		setlayer = "floor",
	},

	decor_missioncontrol_6x4_bigfloorpiece1 =
	{
		build = { "data/anims/Final_missioncontrol/missioncontrol_6x4_bigfloorpiece1.abld"},
		anims = { "data/anims/Final_missioncontrol/missioncontrol_6x4_bigfloorpiece1.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_4x4,
		setlayer = "floor",
	},

	decor_engineroom_1x1_gear2=
	{
		build = { "data/anims/Final_engineroom/engineroom_1x1_gear2.abld", "data/anims/general/mf_coverpieces_1x1.abld" },
		anims = { "data/anims/Final_engineroom/engineroom_1x1_gear4.adef", "data/anims/general/mf_coverpieces_1x1.adef" },
		anim = "idle",
		scale = 0.25,
		layer = Layer.Object,
		boundType = BoundType.bound_1x1_med_big,
		filterSymbols = {{symbol="icon",filter="default"}},
	},

	decor_holostorage_1x1_wallgear1 =
	{
		build = { "data/anims/Final_holostorage/holostorage_2x1_wallgear1.abld" },
		anims = { "data/anims/Final_holostorage/holostorage_2x1_wallgear1.adef" },
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Wall2,
		filterSymbols = {{symbol="light",filter="default"}},
	},

	decor_ftm_lab_flooring_1x1rug1=
	{
		build = { "data/anims/FTM_office/ftm_office_flooring_1x1_rug1.abld"},
		anims = { "data/anims/FTM_office/ftm_office_flooring_1x1_rug1.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_2x3,
		setlayer = "floor",
	},

	
	decor_ftm_lab_flooring_1x1rug2=
	{
		build = { "data/anims/FTM_office/ftm_office_flooring_1x1_rug2.abld"},
		anims = { "data/anims/FTM_office/ftm_office_flooring_1x1_rug2.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_2x2,
		setlayer = "floor",
	},

	decor_ftm_lab_flooring_1x1rug3=
	{
		build = { "data/anims/FTM_office/ftm_office_flooring_1x1_rug3.abld"},
		anims = { "data/anims/FTM_office/ftm_office_flooring_1x1_rug3.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_1x2,
		setlayer = "floor",
	},

	decor_ftm_lab_flooring_1x1rug4=
	{
		build = { "data/anims/FTM_office/ftm_office_flooring_1x1_rug4.abld"},
		anims = { "data/anims/FTM_office/ftm_office_flooring_1x1_rug4.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x2,
		setlayer = "floor",
	},

	decor_ftm_lab_flooring_1x1rug5=
	{
		build = { "data/anims/FTM_office/ftm_office_flooring_1x1_rug5.abld"},
		anims = { "data/anims/FTM_office/ftm_office_flooring_1x1_rug5.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_3x3,
		setlayer = "floor",
	},

	decor_ftm_hall_flooring_1x1rug4 =
	{
		build = { "data/anims/FTM_hall/ftm_hall_flooring_1x1_rug4.abld"},
		anims = { "data/anims/FTM_hall/ftm_hall_flooring_1x1_rug1.adef"},
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.Floor_2x3,
		setlayer = "floor",
	},

	decor_ko_lab_catwalk1 =
	{
		build = { "data/anims/KO_lab/ko_lab_object_2x1catwalk1.abld", "data/anims/general/mf_coverpieces_1x2.abld" },
		anims = { "data/anims/Seikaku_robobay/seikaku_robobay_object_2x1roboliftupempty1.adef", "data/anims/general/mf_coverpieces_1x2.adef" },
		anim = "idle",
		scale = 0.25,
		boundType = BoundType.bound_2x1_med_med,
	},	


}

return animdefs