local array = include( "modules/array" )
local util = include( "modules/util" )
local cdefs = include( "client_defs" )
local simdefs = include("sim/simdefs")
local simquery = include("sim/simquery")
local abilityutil = include( "sim/abilities/abilityutil" )
local inventory = include("sim/inventory")
local unitdefs = include( "sim/unitdefs" )
local simunit = include( "sim/simunit" )

local buy_pwr =
	{
		name = STRINGS.AMRE.ABILITIES.BUY_PWR,
		COST = 74,
		CPU = 1,
		profile_icon = "gui/icons/icon-item_pwr_small.png",
		usesMP = true,
		HUDpriority = 1,

	createToolTip = function( self,sim,unit,targetCell)
			return abilityutil.formatToolTip(STRINGS.AMRE.ABILITIES.BUY_PWR,util.sformat(STRINGS.AMRE.ABILITIES.BUY_PWR_DESC,self.COST))
			
		end,

		alwaysShow = true,

		getName = function( self, sim, unit )
			return  STRINGS.AMRE.ABILITIES.BUY_PWR
		end,

getProfileIcon = function( self, sim, abilityOwner )
        return abilityOwner:getUnitData().profile_icon or self.profile_icon
    end,

		canUseAbility = function( self, sim, itemUnit, unit )

			if unit:getPlayerOwner() and unit:getPlayerOwner():isPC() and unit:getMP() < 1 then
				return false, string.format(STRINGS.UI.REASON.REQUIRES_AP,1)
			end

			local player = unit:getPlayerOwner() 
			if player:getCredits() < self.COST then
				return false, util.sformat( STRINGS.AMRE.ABILITIES.BUY_PWR_ERROR )
			end

			if player:getCpus( ) >= player:getMaxCpus( ) then
				return false, util.sformat( STRINGS.AMRE.ABILITIES.BUY_PWR_ERROR_FULL )
			end

			return true
		end,
		
		executeAbility = function( self, sim, itemUnit, unit )
			local player = unit:getPlayerOwner()
			local userUnit = itemUnit:getUnitOwner()
			local x0, y0 = unit:getLocation()
			player:addCredits( -1 * self.COST ,sim )
			player:addCPUs( self.CPU, sim )
			sim:dispatchEvent( simdefs.EV_UNIT_FLOAT_TXT, {txt=util.sformat(STRINGS.AMRE.ABILITIES.BUY_PWR_FLY,self.COST),x=x0,y=y0,color={r=1,g=1,b=1,a=1}} ) 
			unit:useMP( simdefs.DEFAULT_COST,sim )		
			sim:dispatchEvent( simdefs.EV_PLAY_SOUND, {sound= "SpySociety/Actions/PWRtoCredits", x=x0,y=y0} )	

			
		end
	}
return buy_pwr