local array = include( "modules/array" )
local util = include( "modules/util" )
local cdefs = include( "client_defs" )
local simdefs = include("sim/simdefs")
local simquery = include("sim/simquery")
local abilityutil = include( "sim/abilities/abilityutil" )
local guarddefs = include("sim/unitdefs/guarddefs")


local change_kanim =
	{
		name = "change_kanim",

		createToolTip = function( self, sim, unit )
			return abilityutil.formatToolTip( STRINGS.ABILITIES.GENERATE_PWR, util.sformat(STRINGS.ABILITIES.GENERATE_PWR_DESC, unit:getTraits().cpus),1)
		end,

		getName = function( self, sim, abilityOwner, abilityUser, targetUnitID )
			return self.name
		end,

		onSpawnAbility = function( self, sim, unit )
			
			self.abilityOwner = unit
			
			local kanim = "kanim_guard_male_ftm"
			local profileBuild = "portraits/portrait_security_build"
			local profileAnim = "portraits/portrait_animation_template"
			local wt = util.weighted_list( sim._patrolGuard )	
			for i = 2, #wt, 2 do
				local template = guarddefs[wt[i]]
				if not template.traits.isDrone then
					kanim = template.kanim	
					profileAnim = template.profile_anim
					profileBuild = template.profile_build						
				end
			end
		 		
			unit:changeKanim( kanim )
			unit.profile_build = profileBuild	
			unit.profile_anim = profileAnim

		end, 

		onDespawnAbility = function( self, sim, unit )
			sim:removeTrigger( simdefs.TRG_ALARM_STATE_CHANGE, self )
		end,
		
		profile_icon = nil,

		canUseAbility = function( self, sim, abilityOwner, unit )
			return true
		end,
		

	}
return change_kanim