local util = include( "modules/util" )
local simdefs = include("sim/simdefs")
local commondefs = include("sim/unitdefs/commondefs")
local itemdefs = include("sim/unitdefs/itemdefs")
local speechdefs = include( "sim/speechdefs" )

---------------------------------------------------------------------------------------------------------
-- NPC templates

local SOUNDS = commondefs.SOUNDS

local DEFAULT_IDLES = commondefs.DEFAULT_IDLES

local DEFAULT_ABILITIES = commondefs.DEFAULT_ABILITIES

local onGuardTooltip = commondefs.onGuardTooltip

local DEFAULT_DRONE = commondefs.DEFAULT_DRONE

local SPIDER_DRONE_SOUNDS =
{
    bio = "",
    escapeVo = "",
	speech="SpySociety/Agents/dialogue_player",  
	stealthstep = simdefs.SOUNDPATH_FOOTSTEP_DRONE_HARDWOOD_NORMAL, 
	step = simdefs.SOUNDPATH_FOOTSTEP_DRONE_HARDWOOD_NORMAL,
					
	wallcover = "SpySociety/Movement/foley_trench/wallcover",
	crouchcover = "SpySociety/Movement/foley_trench/crouchcover",
	fall = "SpySociety/Movement/foley_walkingdrone/fall",					
	fall_knee = "SpySociety/Movement/foley_walkingdrone/fall",
	fall_kneeframe = 9,
	fall_hand = "SpySociety/Movement/foley_walkingdrone/fall",
	fall_handframe = 20,
	land = "SpySociety/Objects/drone/drone_hitground",
	land_frame = 9,						
	getup = "SpySociety/Movement/foley_walkingdrone/getup",
	grabbed = "SpySociety/Movement/foley_walkingdrone/grabbed",
	pin = "SpySociety/Movement/foley_walkingdrone/pin_guard",
	pinned = "SpySociety/Movement/foley_walkingdrone/pinned",	
	peek_fwd = "SpySociety/Actions/Engineer/wireless_emitter",	
	peek_bwd = "SpySociety/Actions/Engineer/wireless_emitter",	
	move ="SpySociety/Movement/foley_walkingdrone/move",
	hit = "SpySociety/HitResponse/hitby_ballistic_metal",
	
-- next sounds not used in current iteration I guess:
	explode = "SpySociety/Objects/drone/drone_explo",					
	explode_frame = 1,
	open = "SpySociety/Objects/drone/drone_open",
	open_frame = 12,
	close = "SpySociety/Objects/drone/drone_close",
	close_frame = 10,
	walk_pre = "SpySociety/Objects/drone/drone_close",
	walk_pst = "SpySociety/Objects/drone/drone_open",
	run_pst = "SpySociety/Objects/drone/drone_open",
	snk_pst = "SpySociety/Objects/drone/drone_open",
}

local npc_templates =
{


	spider_mod = 
	{
		type = "simunit",
		name = STRINGS.AMRE.ITEMS.SPIDER_BOT,
		fullname = STRINGS.AGENTS.HOSTAGE.ALT_1.FULLNAME,
		yearsOfService = STRINGS.AGENTS.HOSTAGE.YEARS_OF_SERVICE,
		age = STRINGS.AGENTS.HOSTAGE.AGE,
		homeTown = STRINGS.AGENTS.HOSTAGE.HOMETOWN,
		toolTip = STRINGS.AMRE.ITEMS.SPIDER_BOT_TIP,
		onWorldTooltip = commondefs.onAgentTooltip,
		profile_icon_36x36= "gui/profile_icons/mod_sp_drone_36.png",
		splash_image = "gui/agents/agentDeckard_768.png",
		profile_anim = "portraits/sankaku_drone_face_new",
		profile_build = "portraits/mod_spider_drone",
		kanim = "kanim_drone_mod",
		
		traits = util.extend( commondefs.DEFAULT_AGENT_TRAITS ) { inventoryMaxSize = 1, neural_scanned = true, mp=8, mpMax =8, noUpgrade = true, hidesInCover = true, noDoorAnim = false, notDraggable = true, dashSoundRange = 4, hits = "spark", isAiming=false, noLoopOverwatch = true, canBeCritical=false, leavesAtEndOfMission=true, canKO = false, empDeath = true, hasHearing = false, augmentMaxSize = 0, dynamicImpass = false, },	
		children = { },
		abilities =  { "jackin", "peek", "escape", "disarmtrap", "observePath", "deactivate_spider_2" } ,
		sounds = SPIDER_DRONE_SOUNDS,
		speech = speechdefs.stealth_1,
		blurb = "",
	},	
	

}

return npc_templates
