---------------------------------------------------------------------
-- Invisible Inc. Mod.
--
local util = include( "modules/util" )
local commondefs = include( "sim/unitdefs/commondefs" )
local simdefs = include( "sim/simdefs" )

local tool_templates =
{
	augment_kpc_pistons = util.extend(commondefs.augment_template)
	{
		name = STRINGS.AMRE.ITEMS.KPC_KO_CHARGE, 
		desc = STRINGS.AMRE.ITEMS.KPC_KO_CHARGE_TIP, 
       		flavor = STRINGS.AMRE.ITEMS.KPC_KO_CHARGE_FLAVOR,
		icon = "itemrigs/FloorProp_AmmoClip.png",
		traits = util.extend( commondefs.DEFAULT_AUGMENT_TRAITS ){
		modTrait = {{"meleeDamage",2}},	
		addTrait = {{"wireless_range",3}},
		wireless_range = 3,		-- hijack
		installed = true,
				},
		profile_icon = "gui/icons/item_icons/items_icon_small/icon-item_kpc_augment_2_small.png",
   	 	profile_icon_100 =  "gui/icons/item_icons/icon-item_kpc_augment_2.png",	
	},	

	augment_mod_mist = util.extend(commondefs.augment_template)
	{
		name = STRINGS.AMRE.ITEMS.MIST_AUGMENT, 
		desc = STRINGS.AMRE.ITEMS.MIST_AUGMENT_TIP, 
       		flavor = STRINGS.AMRE.ITEMS.MIST_AUGMENT_FLAVOR,
		traits = util.extend( commondefs.DEFAULT_AUGMENT_TRAITS ){
		addAbilities = "mindShade",
		installed = true,
				},
		profile_icon = "gui/icons/item_icons/items_icon_small/icon-item_mist_augment_small.png",
   	 	profile_icon_100 =  "gui/icons/item_icons/icon-item_mist_augment.png",	
	},	

	augment_ghuff_pda = util.extend( commondefs.augment_template )
	{
		name = STRINGS.AMRE.ITEMS.GHUFF_PDA,
		desc = STRINGS.AMRE.ITEMS.GHUFF_PDA_TIP,
		flavor = STRINGS.AMRE.ITEMS.GHUFF_PDA_FLAVOR,	

		traits = util.extend( commondefs.DEFAULT_AUGMENT_TRAITS )
        {
            addTrait = {{"doorPeek360",true},{"largeSafeMapIntel",true}},
            installed = true,		
		},
		value = 600, 
		profile_icon = "gui/icons/item_icons/items_icon_small/icon-item_rept_eye_augment_small.png",
   	 	profile_icon_100 =  "gui/icons/item_icons/icon-item_rept_eye_augment.png",				
	},	

	augment_spider_ctrl = util.extend( commondefs.augment_template )
	{
		name = STRINGS.AMRE.ITEMS.SPIDER_CTRL,
		desc = STRINGS.AMRE.ITEMS.SPIDER_CTRL_TIP,
		flavor = STRINGS.AMRE.ITEMS.SPIDER_CTRL_FLAVOR,	

		traits = util.extend( commondefs.DEFAULT_AUGMENT_TRAITS )
        {
		addAbilities = "buy_PWR",
		installed = true,		
		},
		value = 600, 
		profile_icon = "gui/icons/icon-item_augment_nu_small.png",
   	 	profile_icon_100 =  "gui/icons/icon-item_augment_nu.png",				
	},	
	

-- scan grenade use its own ability (throw_2) to drain pwr, real power cost in throw_2.lua, cost here only for tooltip and to check - can be used or not.
item_kpctech_scangrenade = util.extend( commondefs.grenade_template, commondefs.item_template )
	{       
		name = STRINGS.AMRE.ITEMS.KPC_SCANGRENADE,
		desc = STRINGS.ITEMS.GRENADE_SCAN_TOOLTIP,
		--type = "simgrenade",
		flavor = STRINGS.AMRE.ITEMS.KPC_SCANGRENADE_FLAVOR,
		profile_icon = "gui/icons/item_icons/items_icon_small/icon-item_kpc_scan_grenade_small.png",	
		profile_icon_100 = "gui/icons/item_icons/icon-item_kpc_scan_grenade.png",		
		kanim = "kanim_smalgrenade",		
		sounds = {activate = "SpySociety/Grenades/stickycam_deploy", explode="SpySociety/Actions/Engineer/wireless_emitter", bounce="SpySociety/Grenades/bounce" },
		traits = { pwrCost=1, range = 3, aimRange = 2, scan=true, wireless_scan=true, isAgent=true, explodes = 0, throwUnit="item_kpctech_scangrenade_true", keepPathing=true, disposable = false, },
		
		value = 900,
		floorWeight = 3, 
		abilities = { "carryable", "throw_2" },
		ITEM_LIST = true,
		WEAPON_LIST = false,
		AUGMENT_LIST = false,
	},

item_kpctech_scangrenade_true = util.extend( commondefs.grenade_template, commondefs.item_template )
	{       
		name = STRINGS.AMRE.ITEMS.KPC_SCANGRENADE,
		desc = STRINGS.ITEMS.GRENADE_SCAN_TOOLTIP,
		--type = "simgrenade",
		flavor = STRINGS.AMRE.ITEMS.KPC_SCANGRENADE_FLAVOR,
		profile_icon = "gui/icons/item_icons/items_icon_small/icon-item_kpc_scan_grenade_small.png",	
		profile_icon_100 = "gui/icons/item_icons/icon-item_kpc_scan_grenade.png",		
		kanim = "kanim_smalgrenade",		
		sounds = {activate = "SpySociety/Grenades/stickycam_deploy", explode="SpySociety/Actions/Engineer/wireless_emitter", bounce="SpySociety/Grenades/bounce" },
		traits = { pwrCost=1, range = 3, aimRange = 2, scan=true, wireless_scan=true, isAgent=true, hasSight=true, LOSarc = math.pi * 2, explodes = 0, throwUnit="item_kpctech_scangrenade_true", keepPathing=true, disposable = false, },
		
		value = 900,
		floorWeight = 3, 
		abilities = { "carryable", "throw_2" },
		ITEM_LIST = false,
		WEAPON_LIST = false,
		AUGMENT_LIST = false,
	},

item_kpc_tazer = util.extend(commondefs.melee_template)
	{
		name = STRINGS.AMRE.ITEMS.KPC_TAZER,
		desc = STRINGS.AMRE.ITEMS.KPC_TAZER_TIP,
		flavor = STRINGS.AMRE.ITEMS.KPC_TAZER_FLAVOR,
		icon = "itemrigs/FloorProp_AmmoClip.png",
		profile_icon = "gui/icons/item_icons/items_icon_small/icon-item_kpc_tazer_small.png",
		profile_icon_100 = "gui/icons/item_icons/icon-item_kpc_tazer.png",		
		requirements = {  },
		traits = { PWRbonus = 1, damage = 2, melee = true, cooldown = 0, cooldownMax = 3, level = 1, restrictedUse={{agentID="mod_01_pedler",name=STRINGS.AMRE.AGENTS.KPC.NAME}}, },
		value = 0,
		floorWeight = 1,
	},

item_decoy = util.extend( commondefs.grenade_template)
	{
		name = STRINGS.AMRE.ITEMS.DECOY_PACK,
		desc = STRINGS.AMRE.ITEMS.DECOY_PACK_TIP,
		flavor = STRINGS.AMRE.ITEMS.DECOY_PACK_FLAVOR,

		ITEM_LIST = true,
		
		profile_icon = "gui/icons/item_icons/items_icon_small/icon-item_decoy_small.png",
		profile_icon_100 = "gui/icons/item_icons/icon-item_decoy.png",	
		kanim = "kanim_stickycam",	
		uses_mainframe =
		{
			toggle =
			{
				name = STRINGS.AMRE.ITEMS.DECOY_OFF,
				tooltip = STRINGS.AMRE.ITEMS.DECOY_OFF_TIP,
				fn = "toggle" -- global script function
			}
		},		
		abilities ={"carryable" , "recharge", "throw_decoy_2"},		
		sounds = {activate="SpySociety/Grenades/stickycam_deploy", bounce="SpySociety/Grenades/bounce" },
		traits = { cooldown = 0, cooldownMax = 5, decoy=true, disposable= false, range=4, targeting_ignoreLOS=true, agent_filter=true, throwUnit="item_decoy_true", holoProjector = true},
		value = 1200,
		floorWeight = 3, 
		locator=true,
	},

	-- decoy itself:
	item_decoy_true = util.extend(commondefs.item_template)
	{
		type = "simemppack",
		name = STRINGS.AMRE.ITEMS.DECOY,
		desc = STRINGS.AMRE.ITEMS.DECOY_TIP,
		profile_icon = "gui/icons/item_icons/items_icon_small/icon-item_decoy_small.png",
		profile_icon_100 = "gui/icons/item_icons/icon-item_decoy.png",	
		kanim = "kanim_mod_decoy",
		uses_mainframe =
		{
			toggle =
			{
				name = STRINGS.AMRE.ITEMS.DECOY_OFF,
				tooltip = STRINGS.AMRE.ITEMS.DECOY_OFF_TIP,
				fn = "toggle" -- global script function
			}
		},		
		abilities = { "carryable","recharge","prime_decoy_2", },
		traits = { cooldown = 0, cooldownMax = 5, canBeShot = true, anchorShot = true, decoy_pack = true, flash_pack = true, sightable = true, wounds = 0, woundsMax = 1, trigger_mainframe=true, range = 4, attackNeedsLOS=true, canSleep = false, baseDamage = 0, mainframe_icon_on_deploy=true, mainframe_status = "active", agent_filter=true, holoProjector = true, steadyAim = true, },
	sounds = {activate="SpySociety/Actions/holocover_activate", deactivate="SpySociety/Actions/holocover_deactivate", activeSpot="SpySociety/Actions/holocover_run_LP", bounce="SpySociety/Grenades/bounce"},
	},


item_canned_spider = util.extend( commondefs.grenade_template)
	{
		name = STRINGS.AMRE.ITEMS.SPIDER_CAN,
		desc = STRINGS.AMRE.ITEMS.SPIDER_CAN_TIP,
		flavor = STRINGS.AMRE.ITEMS.SPIDER_CAN_FLAVOR,
		ITEM_LIST = false,

		profile_icon = "gui/icons/icon-item_spider_drone_small.png",
		profile_icon_100 = "gui/icons/icon-item_spider_drone.png",	
		icon = "itemrigs/FloorProp_InvisiCloakTimed.png",
		kanim = "kanim_stickycam",	
		abilities ={"carryable" , "recharge", "throw_spider_2"},		
		sounds = {activate="SpySociety/Grenades/stickycam_deploy", bounce="SpySociety/Grenades/bounce" },
		traits = { disposable= false, targeting_ignoreLOS=true, agent_filter=true, pwrCost=6, usesCharges = true, charges = 1, chargesMax = 1, restrictedUse={{agentID="mod_04_n_umi",name=STRINGS.AMRE.AGENTS.NU.NAME}} },
		value = 1200,
	--	floorWeight = 3, 
		locator=true,
	},


	item_power_tazer_extra_weak = util.extend(commondefs.melee_template)
	{
		name = STRINGS.AMRE.ITEMS.TAZER_PWR_WEAK,
		desc = STRINGS.AMRE.ITEMS.TAZER_PWR_WEAK_TOOLTIP,
		flavor = STRINGS.AMRE.ITEMS.TAZER_PWR_WEAK_FLAVOR,
		icon = "itemrigs/FloorProp_AmmoClip.png",
		profile_icon = "gui/icons/item_icons/items_icon_small/icon-item_tazer_pwr_small.png",
		profile_icon_100 = "gui/icons/item_icons/icon-item_tazer_pwr.png",		
		--profile_icon = "gui/items/icon-tazer-ftm.png",
		abilities = { "carryable"},
		requirements = {  },
		traits = { damage = 1,  pwrCost = 2, melee = true, tazer = true, level = 1 },
		value = 150,
		floorWeight = 1,	
		ITEM_LIST = false,
		WEAPON_LIST = false,
		AUGMENT_LIST = false,	
	},


}

	
	

-- Reassign key name to value table.
for id, template in pairs(tool_templates) do
	template.id = id
end

return tool_templates