---------------------------------------------------------------------
-- Invisible Inc. Mod.
--
local util = include( "modules/util" )
local commondefs = include( "sim/unitdefs/commondefs" )
local simdefs = include( "sim/simdefs" )

local tool_templates =
{
	
	item_mod_empgrenade = util.extend( commondefs.grenade_template)
	{
		name = STRINGS.AMRE.ITEMS.EMP_GRENADE,
		desc = STRINGS.AMRE.ITEMS.EMP_GRENADE_TIP,
		flavor = STRINGS.AMRE.ITEMS.EMP_GRENADE_FLAVOR,

		ITEM_LIST = true,

		profile_icon = "gui/icons/item_icons/items_icon_small/icon-item_mod_emp_grenade_small.png",	
		profile_icon_100 = "gui/icons/item_icons/icon-item_mod_emp_grenade.png",	
		kanim = "kanim_flashgrenade",		
		
		abilities ={"carryable" , "throw_emp_2"},		
		sounds = {activate="SpySociety/Grenades/stickycam_deploy", bounce="SpySociety/Grenades/bounce" },
		traits = { range=3, agent_filter=true, attackNeedsLOS=true, disposable= true, throwUnit="item_mod_empgrenade_true"},
		floorWeight = 2,
		value = 150,
		locator=true,
	},

		
	item_mod_empgrenade_true = util.extend(commondefs.item_template)
	{
		type = "simemppack",
		name = STRINGS.AMRE.ITEMS.EMP_GRENADE,
		desc = STRINGS.AMRE.ITEMS.EMP_GRENADE_TIP,
		profile_icon = "gui/icons/item_icons/items_icon_small/icon-item_flash_grenade_small.png",	
		profile_icon_100 = "gui/icons/item_icons/icon-item_flash_grenade.png",	
		kanim = "kanim_flashgrenade",	
		abilities = { "carryable", "prime_emp", },
		traits = { range = 3, canSleep = false, baseDamage = 0, agent_filter=true, emp_duration = 2 },
	sounds = {activate="SpySociety/Actions/holocover_activate", deactivate="SpySociety/Actions/holocover_deactivate", activeSpot="SpySociety/Actions/holocover_run_LP", bounce="SpySociety/Grenades/bounce"},
	},


	item_remote_emp = util.extend( commondefs.item_template )
	{
		name = STRINGS.AMRE.ITEMS.REMOTE_OVERLOAD,
		desc = STRINGS.AMRE.ITEMS.REMOTE_OVERLOAD_TIP,
		flavor = STRINGS.AMRE.ITEMS.REMOTE_OVERLOAD_FLAVOR,
		ITEM_LIST = true,
		icon = "itemrigs/FloorProp_MotionDetector.png",	
		profile_icon = "gui/icons/item_icons/items_icon_small/icon-item_remote_emp_small.png",
		profile_icon_100 = "gui/icons/item_icons/icon-item_remote_emp.png",	
		overload_icon = "gui/icons/programs_icons/Programs_icon_small/icon-program_overload_small.png",				
		abilities = { "remote_emp_2", "wireless_discharge_2", "recharge", "carryable" },
		traits = { cooldown = 0, cooldownMax = 6, usesCharges = true, charges = 4, chargesMax = 4, range = 6, },
		sounds = { reload="SpySociety/Weapons/LowBore/reload_handgun", use="SpySociety/Actions/item_pickup"},
		floorWeight = 3, 
		value = 1200,
	},	


}

-- Reassign key name to value table.
for id, template in pairs(tool_templates) do
	template.id = id
end

return tool_templates