local simdefs = include("sim/simdefs")
local mainframe_common = include("sim/abilities/mainframe_common")
local DEFAULT_ABILITY = mainframe_common.DEFAULT_ABILITY

local lonestart =
{	
	onSpawnAbility = function( self, sim, unit )
		sim:addTrigger( simdefs.TRG_START_TURN, self )	
	end, 
		
	onTrigger = function( self, sim, evType, evData )
	DEFAULT_ABILITY.onTrigger( self, sim, evType, evData )
	local player = sim:getCurrentPlayer()
	local user = savefiles.getCurrentGame()
	local campaign = user.data.saveSlots[ user.data.currentSaveSlot ]
	local params = sim:getParams()
	local situationName = params.situationName

		if player:isPC() then
	        	for _, unit in pairs(sim:getAllUnits()) do
	                	if unit:getTraits().mod_lonestart then
	                        	unit:killUnit( sim )						    
				 			    
				local event = {
					eventType = simdefs.CAMPAIGN_EVENTS.REMOVE_AGENT,
				        mission = situationName,   
				        data = 0,
				    }    
				 
				table.insert(campaign.campaignEvents,event) 			
				log:write( "Set to remove: 'Lone_Start %s, after: ", tostring(event.data) )
				log:write( event.mission)
	
				end	
					          
	         	end
	        end
   	end,       
}
return lonestart