---------------------------------------------------------------------
-- Invisible Inc. MOD.

local util = include( "modules/util" )
local simquery = include( "sim/simquery" )
local simdefs = include( "sim/simdefs" )
local agentdefs = include("sim/unitdefs/agentdefs")
local array = include( "modules/array" )

-- init will be called once
local function init( modApi )

    log:write("inside the Agent Mods Combo by Shirsh")
    local dataPath = modApi:getDataPath()
    local scriptPath = modApi:getScriptPath()   

rawset(_G,"SCRIPT_PATHS",rawget(_G,"SCRIPT_PATHS") or {})
    	SCRIPT_PATHS.Shirsh_prefabs = scriptPath

include( scriptPath .. "/lib_sequentialModLoader" )( modApi )
	modApi.requirements = { "Contingency Plan", "Sim Constructor", "Interactive Events", "Rescueable Archive Agents", "Dr.Pedler", "Mist", "Ghuff", "N-Umi", "Gunpoint", "Advanced Guard Protocol", "New Items And Augments"}
    
    -- Mount data (icons, agent upgrade pic).
	KLEIResourceMgr.MountPackage( dataPath .. "/drpedler.kwad", "data" ) 
	KLEIResourceMgr.MountPackage( dataPath .. "/engineer.kwad", "data" ) 
	KLEIResourceMgr.MountPackage( dataPath .. "/drpedler_grp_anim.kwad", "data/anims" ) 
	KLEIResourceMgr.MountPackage( dataPath .. "/ghuff.kwad", "data" ) 
	KLEIResourceMgr.MountPackage( dataPath .. "/ghuff_gui.kwad", "data" ) 
	KLEIResourceMgr.MountPackage( dataPath .. "/mist.kwad", "data" ) 
	KLEIResourceMgr.MountPackage( dataPath .. "/mist_gui.kwad", "data" ) 
	KLEIResourceMgr.MountPackage( dataPath .. "/new.kwad", "data" ) 
	KLEIResourceMgr.MountPackage( dataPath .. "/guns.kwad", "data" ) 
	KLEIResourceMgr.MountPackage( dataPath .. "/ko_med.kwad", "data/anims" ) 
	KLEIResourceMgr.MountPackage( dataPath .. "/guards_anims.kwad", "data" ) 
	KLEIResourceMgr.MountPackage( dataPath .. "/guards_gui.kwad", "data" ) 
	KLEIResourceMgr.MountPackage( dataPath .. "/portraits.kwad", "data" ) 	
	KLEIResourceMgr.MountPackage( dataPath .. "/lonestart.kwad", "data" ) 
	KLEIResourceMgr.MountPackage( dataPath .. "/mod_agent_hud.kwad", "data" )
	KLEIResourceMgr.MountPackage( dataPath .. "/shared_female_hit_fix.kwad", "data" )
	KLEIResourceMgr.MountPackage( dataPath .. "/pedler_oil.kwad", "data" )
	--KLEIResourceMgr.MountPackage( dataPath .. "/mod_combo.kwad", "data" )

    -- Load MOD strings.  
    local DLC_STRINGS = include( scriptPath .. "/strings" )
    modApi:addStrings( dataPath, "AMRE", DLC_STRINGS )
    
      
    local scriptPath = modApi:getScriptPath()  
	modApi:addAbilityDef( "breakDoor_2", scriptPath .."/breakDoor_2" )
	modApi:addAbilityDef( "throw_2", scriptPath .."/throw_2" )
	modApi:addAbilityDef( "melee", scriptPath .."/melee" ) 
	modApi:addAbilityDef( "mindShade", scriptPath .."/mindShade" ) 
	modApi:addAbilityDef( "prime_decoy_2", scriptPath .."/prime_decoy_2" ) 
	modApi:addAbilityDef( "throw_decoy_2", scriptPath .."/throw_decoy_2" ) 
	modApi:addAbilityDef( "throw_emp_2", scriptPath .."/throw_emp_2" )
	modApi:addAbilityDef( "remote_emp_2", scriptPath .."/remote_emp_2" )
	modApi:addAbilityDef( "buy_PWR", scriptPath .."/buy_PWR" )
	modApi:addAbilityDef( "throw_spider_2", scriptPath .."/throw_spider_2" ) 
	modApi:addAbilityDef( "deactivate_spider_2", scriptPath .."/deactivate_spider_2" )
	modApi:addAbilityDef( "lonestart", scriptPath .."/lonestart" ) 
	modApi:addAbilityDef( "change_kanim", scriptPath .."/change_kanim" )
	modApi:addAbilityDef( "wireless_discharge_2", scriptPath .."/wireless_discharge_2" )
	 
    --Options:
  	modApi:addGenerationOption("agentsAndItems", STRINGS.AMRE.OPTIONS.ENABLE_AGENTS , STRINGS.AMRE.OPTIONS.ENABLE_AGENTS_TIP,{noUpdate=true})
	
	modApi:addGenerationOption("throwEMP", STRINGS.AMRE.OPTIONS.EMP , STRINGS.AMRE.OPTIONS.EMP_TIP ,{noUpdate=true})
	modApi:addGenerationOption("deckerGun", STRINGS.AMRE.OPTIONS.GUNS , STRINGS.AMRE.OPTIONS.GUNS_TIP,{noUpdate=true})
	modApi:addGenerationOption("handguns", STRINGS.AMRE.OPTIONS.HANDGUNS , STRINGS.AMRE.OPTIONS.HANDGUNS_TIP,{noUpdate=true})
	modApi:addGenerationOption("checkbox", STRINGS.AMRE.OPTIONS.CHECKBOX , STRINGS.AMRE.OPTIONS.CHECKBOX_TIP,{noUpdate=true})
	modApi:addGenerationOption("archivedPortraits", STRINGS.AMRE.OPTIONS.ENABLE_PORTRAITS , STRINGS.AMRE.OPTIONS.ENABLE_PORTRAITS_TIP,{noUpdate=true})
  	modApi:addGenerationOption("loneStart", STRINGS.AMRE.OPTIONS.ENABLE_LONESTART , STRINGS.AMRE.OPTIONS.ENABLE_LONESTART_TIP,{noUpdate=true})
	modApi:addGenerationOption("incidents", STRINGS.AMRE.OPTIONS.INCIDENTS , STRINGS.AMRE.OPTIONS.INCIDENTS_TIP, {noUpdate = true})  
	modApi:addGenerationOption("noWireframes", STRINGS.AMRE.OPTIONS.WIREFRAMES , STRINGS.AMRE.OPTIONS.WIREFRAMES_TIP,{noUpdate=true})
	modApi:addGenerationOption("newEntryRooms", STRINGS.AMRE.OPTIONS.NEW_ENTRY_ROOMS , STRINGS.AMRE.OPTIONS.NEW_ENTRY_ROOMS_TIP,{noUpdate=true})
	modApi:addGenerationOption("newRooms", STRINGS.AMRE.OPTIONS.NEW_ROOMS , STRINGS.AMRE.OPTIONS.NEW_ROOMS_TIP,{noUpdate=true})
	modApi:addGenerationOption("newExitRooms", STRINGS.AMRE.OPTIONS.NEW_EXIT_ROOMS , STRINGS.AMRE.OPTIONS.NEW_EXIT_ROOMS_TIP,{noUpdate=true})
	modApi:addGenerationOption("Pedler_detention", STRINGS.AMRE.OPTIONS.PEDLER_DETENTION , STRINGS.AMRE.OPTIONS.PEDLER_DETENTION_TIP,{noUpdate=true})
	modApi:addGenerationOption("Mist_detention", STRINGS.AMRE.OPTIONS.MIST_DETENTION , STRINGS.AMRE.OPTIONS.MIST_DETENTION_TIP,{noUpdate=true})
	modApi:addGenerationOption("Ghuff_detention", STRINGS.AMRE.OPTIONS.GHUFF_DETENTION , STRINGS.AMRE.OPTIONS.GHUFF_DETENTION_TIP,{noUpdate=true})
	modApi:addGenerationOption("N_Umi_detention", STRINGS.AMRE.OPTIONS.NUMI_DETENTION , STRINGS.AMRE.OPTIONS.NUMI_DETENTION_TIP,{noUpdate=true})    

end

-- load may be called multiple times with different options enabled
local function load( modApi, options )

	local scriptPath = modApi:getScriptPath()
	local commondefs = include( scriptPath .. "/commondefs" )

-- fixes for some props being set up a bit wrong and being not shown at game (like many rugs), glass walls being shown incorrectly in tactical mode etc
	local animdefs_fixes = include( scriptPath .. "/animdefs_fixes" )
	    for name, animDef in pairs(animdefs_fixes) do
	        modApi:addAnimDef( name, animDef )
	    end    
-- fix for courier wrong sound filename for crouch movement that spams log otherwise	
	if agentdefs.hostage then
   		agentdefs.hostage.sounds.crouchcover = "SpySociety/Movement/foley_suit/crouchcover"
	end	



if options["newEntryRooms"] and options["newEntryRooms"].enabled then

	local sharedPrefabs = include( scriptPath .. "/prefabs_entries/shared/prefabt" )
    modApi:addPrefabt(sharedPrefabs)

 	local koPrefabs = include( scriptPath .. "/prefabs_entries/ko/prefabt" )
    modApi:addWorldPrefabt(scriptPath, "ko", koPrefabs)

	local ftmPrefabs = include( scriptPath .. "/prefabs_entries/ftm/prefabt" )
    modApi:addWorldPrefabt(scriptPath, "ftm", ftmPrefabs)

	local skPrefabs = include( scriptPath .. "/prefabs_entries/sankaku/prefabt" )
    modApi:addWorldPrefabt(scriptPath, "sankaku", skPrefabs)

	local plastechPrefabs = include( scriptPath .. "/prefabs_entries/plastech/prefabt" )
    modApi:addWorldPrefabt(scriptPath, "plastech", plastechPrefabs)

	end

 if options["newRooms"] and options["newRooms"].enabled then

	local sharedPrefabs = include( scriptPath .. "/prefabs/shared/prefabt" )
    modApi:addPrefabt(sharedPrefabs)

 --	local koPrefabs = include( scriptPath .. "/prefabs/ko/prefabt" )
 --   modApi:addWorldPrefabt(scriptPath, "ko", koPrefabs)

--	local ftmPrefabs = include( scriptPath .. "/prefabs/ftm/prefabt" )
  --  modApi:addWorldPrefabt(scriptPath, "ftm", ftmPrefabs)

--	local skPrefabs = include( scriptPath .. "/prefabs/sankaku/prefabt" )
  --  modApi:addWorldPrefabt(scriptPath, "sankaku", skPrefabs)

	--local plastechPrefabs = include( scriptPath .. "/prefabs/plastech/prefabt" )
    --modApi:addWorldPrefabt(scriptPath, "plastech", plastechPrefabs)

	end
if options["newExitRooms"] and options["newExitRooms"].enabled then

	local sharedPrefabs = include( scriptPath .. "/prefabs_exits/shared/prefabt" )
    modApi:addPrefabt(sharedPrefabs)

	end


-- Removed wireframes:

    if options["noWireframes"].enabled then
        
	 local animdefs = include( scriptPath .. "/animdefs_no_wireframes" )
    for name, animDef in pairs(animdefs) do
        modApi:addAnimDef( name, animDef )
    end    	
			
    end

 -- Agents and their stuff:
 
    if options["agentsAndItems"].enabled then
      
	local agentdefs = include( scriptPath .. "/agentdefs" )
        for name, agentDef in pairs(agentdefs) do
            modApi:addAgentDef( name, agentDef, { name } )
        end
        
        local itemdefs = include( scriptPath .. "/itemdefs" )
        for name, itemDef in pairs(itemdefs) do
            modApi:addItemDef( name, itemDef )
        end   
	
	 local animdefs = include( scriptPath .. "/animdefs" )
    for name, animDef in pairs(animdefs) do
        modApi:addAnimDef( name, animDef )
    end     

	local guarddefs = include( scriptPath .. "/guarddefs" )
        for name, guarddef in pairs(guarddefs) do
            modApi:addGuardDef( name, guarddef )
        end


	
end

--detention 
if options["Pedler_detention"] and options["Pedler_detention"].enabled then
	--add them to the detention centres:
	       local serverdefs = include( scriptPath .. "/serverdefs_pedler" )     
    if serverdefs.TEMPLATE_AGENCY and serverdefs.TEMPLATE_AGENCY.unitDefsPotential then
        for i,unitDef in ipairs(serverdefs.TEMPLATE_AGENCY.unitDefsPotential) do
            if not array.findIf( include( "modules/serverdefs" ).TEMPLATE_AGENCY.unitDefsPotential , function( t ) return  t.id ==  unitDef.id end ) then
                modApi:addRescueAgent( unitDef )
            end
            end
       end
end

if options["Mist_detention"] and options["Mist_detention"].enabled then
	--add them to the detention centres:
	       local serverdefs = include( scriptPath .. "/serverdefs_mist" )    
    if serverdefs.TEMPLATE_AGENCY and serverdefs.TEMPLATE_AGENCY.unitDefsPotential then
        for i,unitDef in ipairs(serverdefs.TEMPLATE_AGENCY.unitDefsPotential) do
            if not array.findIf( include( "modules/serverdefs" ).TEMPLATE_AGENCY.unitDefsPotential , function( t ) return  t.id ==  unitDef.id end ) then
                modApi:addRescueAgent( unitDef )
            end
            end
       end
end

if options["Ghuff_detention"] and options["Ghuff_detention"].enabled then
	--add them to the detention centres:
	       local serverdefs = include( scriptPath .. "/serverdefs_ghuff" )       
    if serverdefs.TEMPLATE_AGENCY and serverdefs.TEMPLATE_AGENCY.unitDefsPotential then
        for i,unitDef in ipairs(serverdefs.TEMPLATE_AGENCY.unitDefsPotential) do
            if not array.findIf( include( "modules/serverdefs" ).TEMPLATE_AGENCY.unitDefsPotential , function( t ) return  t.id ==  unitDef.id end ) then
                modApi:addRescueAgent( unitDef )
            end
            end
       end
end

if options["N_Umi_detention"] and options["N_Umi_detention"].enabled then
	--add them to the detention centres:
	       local serverdefs = include( scriptPath .. "/serverdefs_numi" )       
    if serverdefs.TEMPLATE_AGENCY and serverdefs.TEMPLATE_AGENCY.unitDefsPotential then
        for i,unitDef in ipairs(serverdefs.TEMPLATE_AGENCY.unitDefsPotential) do
            if not array.findIf( include( "modules/serverdefs" ).TEMPLATE_AGENCY.unitDefsPotential , function( t ) return  t.id ==  unitDef.id end ) then
                modApi:addRescueAgent( unitDef )
            end
            end
       end
end

	local simdefs = include("sim/simdefs")
	local incidents = include(scriptPath.."/incidents")
	if options["incidents"] and options["incidents"].enabled and rawget(simdefs,"INCIDENTS") then	
		log:write( "Incidents" )
		for incident, weight in pairs(incidents["remove"]) do			
			local incidentName = include(scriptPath.."/Incidents/"..incident).incidentName		
			--if simdefs.INCIDENTS.incidentName then 	 		
				table.remove(simdefs.INCIDENTS,incidentName)
				--log:write( "Incident removed" )
			--end			
		end

		for incident, weight in pairs(incidents["overwrite"]) do			
			local incidentName = include(scriptPath.."/Incidents/"..incident).incidentName		
			--if simdefs.INCIDENTS.incidentName then 		
				table.remove(simdefs.INCIDENTS,incidentName)			
				table.insert(simdefs.INCIDENTS,{include(scriptPath.."/Incidents/"..incident),weight})
				--log:write( "Incident overwritten" )
			--end
						
		end		

		local propdefs = include( "sim/unitdefs/propdefs" )		
		if propdefs.neutral_agent ~= nil then					
			propdefs.neutral_agent.abilities = { "talkable", "change_kanim" }	
		end	

		local propdefs_add = include( scriptPath .. "/propdefs" )
		for i,item in pairs(propdefs_add) do  
			local threats = false 
			modApi:addPropDef( i, item, threats )
		end		
		
	end


-- okay, here's come the banter

--[[
 if options["addBanter"] and options["agentsAndItems"].enabled	and options["addBanter"].enabled then
	
	local banterdefs = include( scriptPath.."/banterdefs" )
	for i,  banter in pairs( banterdefs ) do
	        modApi:addBanter( banter )
	end

	if agentdefs.draco ~= nil then
		local banterdefsDLC = include( scriptPath.."/banterdefsDLC" )
		    for i,  banter in pairs( banterdefsDLC ) do
		        modApi:addBanter( banter )
		    end
	end
	
 end
]]

	 if options["deckerGun"].enabled then
        
	 local animdefs = include( scriptPath .. "/animdefs_deckerGun" )
	    for name, animDef in pairs(animdefs) do
	        modApi:addAnimDef( name, animDef )
	    end    	

	local itemdefs = include( "sim/unitdefs/itemdefs" )
	if itemdefs.item_revolver_deckard then
        	itemdefs.item_revolver_deckard.weapon_anim = "kanim_decker_revolver"
        end  
			
    end
	local agents = include( "sim/unitdefs/agentdefs" )
	if options["archivedPortraits"].enabled then
      		 
		if agents.stealth_1 then
	   		agents.stealth_1.team_select_img = {"gui/agents/team_select_1_deckard_ea.png",	}
		end
		if agents.stealth_1_a then
			agents.stealth_1_a.profile_build = "portraits/stealth_guy_face_2"
			agents.stealth_1_a.profile_icon_36x36 = "gui/profile_icons/stealth2_36.png"
		end
		if agents.sharpshooter_1 then
	   		agents.sharpshooter_1.profile_build = "portraits/sharpshooter_face_1"
			agents.sharpshooter_1.team_select_img = {"gui/agents/team_select_1_shalem_ea.png",	}
		end
		if agents.engineer_1 then
			agents.engineer_1.profile_build = "portraits/dr_tony_face_1"
		end
		if agents.engineer_1_a then
			agents.engineer_1_a.profile_build = "portraits/dr_tony_face_2"			
		end
		if agents.stealth_2_a then
			agents.stealth_2_a.profile_build = "portraits/lady_stealth_face_2"
			agents.stealth_2_a.profile_icon_36x36= "gui/profile_icons/lady_stealth2_36.png"
		end
		if agents.engineer_2 then
			agents.engineer_2.profile_build = "portraits/lady_tech_face_1"			
		end
		if agents.engineer_2_a then
			agents.engineer_2_a.profile_build = "portraits/lady_tech_face_2"			
		end
		if agents.sharpshooter_2_a then
			agents.sharpshooter_2_a.profile_build = "portraits/lady_sharpshooter_face_2"
			agents.sharpshooter_2_a.profile_icon_36x36= "gui/profile_icons/lady_sharpshooter2_36.png"
		end
		if agents.cyborg_1_a then
			agents.cyborg_1_a.profile_build = "portraits/robo_alex_face_2"				
		end
		if agents.disguise_1_a then
			agents.disguise_1_a.profile_build = "portraits/prism_face_2"			
		end
	
		else		-- THIS IS NEW -Hekateras
		
		
		local agents = include( "sim/unitdefs/agentdefs" )
	
		if agents.stealth_1_a then
			agents.stealth_1_a.profile_build = "portraits/stealth_guy_face"

		end
		if agents.sharpshooter_1 then
	   		agents.sharpshooter_1.profile_build = "portraits/sharpshooter_face"

		end
		if agents.engineer_1 then
			agents.engineer_1.profile_build = "portraits/dr_tony_face"
		end
		if agents.engineer_1_a then
			agents.engineer_1_a.profile_build = "portraits/dr_tony_face"			
		end
		if agents.stealth_2_a then
			agents.stealth_2_a.profile_build = "portraits/lady_stealth_face"
		end
		if agents.engineer_2 then
			agents.engineer_2.profile_build = "portraits/lady_tech_face"			
		end
		if agents.engineer_2_a then
			agents.engineer_2_a.profile_build = "portraits/lady_tech_face"			
		end
		if agents.sharpshooter_2_a then
			agents.sharpshooter_2_a.profile_build = "portraits/lady_sharpshooter_face"

		end
		if agents.cyborg_1_a then
			agents.cyborg_1_a.profile_build = "portraits/robo_alex_face"				
		end
		if agents.disguise_1_a then
			agents.disguise_1_a.profile_build = "portraits/prism_face"			
		end
        	
    	end

 	if options["handguns"].enabled then
        
	local animdefs = include( scriptPath .. "/animdefs_handguns" )
  	for name, animDef in pairs(animdefs) do
        	modApi:addAnimDef( name, animDef )
 	end    	
			
   	end

	 if options["throwEMP"].enabled then
        
	 local itemdefs = include( scriptPath .. "/itemdefs_emp" )
        for name, itemDef in pairs(itemdefs) do
            modApi:addItemDef( name, itemDef )
        end  	
			
    end

	if options["loneStart"].enabled then

-- technically "no agent" option is an agent with id = 0, who "kill itself" via "lonestart" ability at start of player's turn
-- and being removed from agency end of this  mission via Campaign Event "RemoveAgent", it prevent him from being marked as MIA and imprisoned.
      	
	local agentdefs = include( scriptPath .. "/agentdefs_lone" )
        for name, agentDef in pairs(agentdefs) do
            modApi:addAgentDef( name, agentDef, { name } )
	end

	local animdefs = include( scriptPath .. "/animdefs_lone" )
    for name, animDef in pairs(animdefs) do
        modApi:addAnimDef( name, animDef )
    end  
	
	
    end




 end

 local function unload()
 
 local agents = include( "sim/unitdefs/agentdefs" )
	
		if agents.stealth_1_a then
			agents.stealth_1_a.profile_build = "portraits/stealth_guy_face"

		end
		if agents.sharpshooter_1 then
	   		agents.sharpshooter_1.profile_build = "portraits/sharpshooter_face"

		end
		if agents.engineer_1 then
			agents.engineer_1.profile_build = "portraits/dr_tony_face"
		end
		if agents.engineer_1_a then
			agents.engineer_1_a.profile_build = "portraits/dr_tony_face"			
		end
		if agents.stealth_2_a then
			agents.stealth_2_a.profile_build = "portraits/lady_stealth_face"
		end
		if agents.engineer_2 then
			agents.engineer_2.profile_build = "portraits/lady_tech_face"			
		end
		if agents.engineer_2_a then
			agents.engineer_2_a.profile_build = "portraits/lady_tech_face"			
		end
		if agents.sharpshooter_2_a then
			agents.sharpshooter_2_a.profile_build = "portraits/lady_sharpshooter_face"

		end
		if agents.cyborg_1_a then
			agents.cyborg_1_a.profile_build = "portraits/robo_alex_face"				
		end
		if agents.disguise_1_a then
			agents.disguise_1_a.profile_build = "portraits/prism_face"			
		end
 end

return {
    init = init,
    load = load,
	unload = unload,
}