-- file called "%skillname_2" simply in case if anyone will make ability with same name. Lamest failsafe. But it sort of my tradition from 1st mod so whatever, I keep doing it. 
local array = include( "modules/array" )
local util = include( "modules/util" )
local cdefs = include( "client_defs" )
local simdefs = include("sim/simdefs")
local simquery = include("sim/simquery")
local inventory = include("sim/inventory")
local abilityutil = include( "sim/abilities/abilityutil" )
local mathutil = include( "modules/mathutil" )
local unitdefs = include( "sim/unitdefs" )
local simunit = include( "sim/simunit" )
local simfactory = include( "sim/simfactory" )
local modifiers = include( "sim/modifiers" )
local mainframe = include( "sim/mainframe" )
local mainframe_common = include("sim/abilities/mainframe_common")
local DEFAULT_ABILITY = mainframe_common.DEFAULT_ABILITY


--local wireless_emp_tooltip = class()
local wireless_emp_tooltip = class( abilityutil.hotkey_tooltip )
function wireless_emp_tooltip:init( hud, abilityOwner, abilityUser, targetUnitID )
	self._hud = hud
	self._abilityOwner = abilityOwner
	self._abilityUser = abilityUser
	self._targetUnitID = targetUnitID	
end

function wireless_emp_tooltip:setPosition( wx, wy )
	--self._panel:setPosition( self._hud._screen:wndToUI( wx, wy ))
end

function wireless_emp_tooltip:getScreen()
	return self._hud._screen
end

function wireless_emp_tooltip:activate( screen )		
	self._hud._game.boardRig:getUnitRig( self._targetUnitID )._prop:setRenderFilter( { shader=KLEIAnim.SHADER_HILITE,r=255/255,g= 255/255,b= 0/255,	a=0.8,	lum=1.0-0.41 } )	
end

function wireless_emp_tooltip:deactivate()	
	self._hud._game.boardRig:getUnitRig( self._targetUnitID )._prop:setRenderFilter( nil )	
end

local wireless_emp =
{
	name = STRINGS.AMRE.ABILITIES.OVERLOAD,
	profile_icon = "gui/icons/action_icons/Action_icon_Small/icon-item_hijack_small.png",
 	proxy = true,
	usesAction = true,
	
	createToolTip = function( self,sim, abilityOwner, abilityUser, targetID )
		if targetID == nil then
			return
		end
		local targetUnit = sim:getUnit( targetID )
		local headerTxt = string.format( STRINGS.AMRE.ABILITIES.OVERLOAD, util.toupper( targetUnit:getName() ) )
		local bodyTxt = string.format( STRINGS.AMRE.ABILITIES.OVERLOAD_TOOLTIP, util.toupper( targetUnit:getName() ) )
		return abilityutil.formatToolTip( headerTxt, bodyTxt, simdefs.DEFAULT_COST )
	end,

	onTooltip = function( self, hud, sim, abilityOwner, abilityUser, targetUnit )
		if targetUnit == nil then
			return
		end
		return wireless_emp_tooltip( hud, abilityOwner, abilityUser, targetUnit )
	end,
		
	getName = function( self, sim, unit )
		return STRINGS.ABILITIES.ICEBREAK
	end,

	getProfileIcon = function( self, sim, abilityOwner )
        	return abilityOwner:getUnitData().profile_icon or self.profile_icon
    	end,

	acquireTargets = function( self, targets, game, sim, unit )
		if not self:canUseAbility( sim, unit ) then
			return --nil
		end
		local userUnit = unit:getUnitOwner()
        	assert( userUnit, tostring(unit and unit:getName())..", "..tostring(unit:getLocation()) )
		local cell = sim:getCell( userUnit:getLocation() )
        	local cells = { cell }

		for dir, exit in pairs(cell.exits) do
            		if simquery.isOpenExit( exit ) then
                		table.insert( cells, exit.cell )
            		end
        	end

		local range = 12
		if unit:getTraits().range then
			range = unit:getTraits().range
		end

		local units = {}
		local x0, y0 = userUnit:getLocation()

		for _, targetUnit in pairs(sim:getAllUnits()) do
			if (targetUnit:getTraits().mainframe_ice or 0) > 0  and targetUnit:getTraits().mainframe_status ~= "off" or targetUnit:getTraits().heartMonitor == "enabled" then
				local x1,y1 = targetUnit:getLocation()
				local distance =  mathutil.dist2d( x0, y0, x1, y1 )
				if sim:canUnitSeeUnit( userUnit, targetUnit ) and distance <= range then
					table.insert( units, targetUnit )
				end
				
			end
		end 		
		return targets.unitTarget( game, units, self, unit, userUnit )
	end,
		
	canUseAbility = function( self, sim, unit )
		-- Must have a user owner.
		local userUnit = unit:getUnitOwner()
		if not userUnit then
			return false
		end
		if unit:getTraits().cooldown and unit:getTraits().cooldown > 0 then
			return false, nil --util.sformat(STRINGS.UI.REASON.COOLDOWN,unit:getTraits().cooldown)
		end
		if unit:getTraits().usesCharges and unit:getTraits().charges < 1 then
			return false, nil --util.sformat(STRINGS.UI.REASON.CHARGES)
		end
		if userUnit:getAP() < 1 then 
			return false, nil --STRINGS.UI.REASON.ATTACK_USED
		end
		
        return abilityutil.checkRequirements( unit, userUnit)
	end,
		
	executeAbility = function( self, sim, unit, userUnit, target )
		local mainframe = include( "sim/mainframe" )
		local userUnit = unit:getUnitOwner()
		local target = sim:getUnit(target)	
					
		local x0,y0 = userUnit:getLocation()
		local x1,y1 = target:getLocation()
		local oldFacing = userUnit:getFacing()
  		local newFacing = simquery.getDirectionFromDelta(x1-x0,y1-y0) 
		local pinning, pinnee = simquery.isUnitPinning(unit:getSim(), userUnit)
		
		if pinning and pinnee == target then
			newFacing = pinnee:getFacing()
		else
			pinning = false
		end


		simquery.suggestAgentFacing(unit, newFacing)

	    	if userUnit:getTraits().monster_hacking then 
			userUnit:getTraits().monster_hacking = false
		    userUnit:getSounds().spot = nil
		end
        						
		if userUnit:getTraits().data_hacking then 
			userUnit:stopHacking(sim)
	    	end
	
		sim:dispatchEvent( simdefs.EV_PLAY_SOUND, {sound= "SpySociety/Objects/computer_shutdown", x=x1,y=y1} )
	      	target:processEMP( 2 )
		userUnit:useAP( sim )
		inventory.useItem( sim, userUnit, unit )
		
		if userUnit:isValid() then							
			sim:dispatchEvent( simdefs.EV_UNIT_REFRESH, { unit = userUnit  } )
		end
	end,
}

return wireless_emp