-- file called "%skillname_2" simply in case if anyone will make ability with same name. Lamest failsafe. But it sort of my tradition from 1st mod so eh whatever. 
local array = include( "modules/array" )
local util = include( "modules/util" )
local cdefs = include( "client_defs" )
local simdefs = include("sim/simdefs")
local simquery = include("sim/simquery")
local inventory = include("sim/inventory")
local abilityutil = include( "sim/abilities/abilityutil" )
local mathutil = include( "modules/mathutil" )
local unitdefs = include( "sim/unitdefs" )
local simunit = include( "sim/simunit" )
local simfactory = include( "sim/simfactory" )
local modifiers = include( "sim/modifiers" )
local mainframe = include( "sim/mainframe" )
local mainframe_common = include("sim/abilities/mainframe_common")
local DEFAULT_ABILITY = mainframe_common.DEFAULT_ABILITY

--local discharge_tooltip = class( abilityutil.hotkey_tooltip )



local discharge_tooltip = class()
function discharge_tooltip:init( hud, abilityOwner, abilityUser, targetUnitID )
	self._hud = hud
	self._abilityOwner = abilityOwner
	self._abilityUser = abilityUser
	self._targetUnitID = targetUnitID	
end

function discharge_tooltip:setPosition( wx, wy )
	--self._panel:setPosition( self._hud._screen:wndToUI( wx, wy ))
end

function discharge_tooltip:getScreen()
	return self._hud._screen
end

function discharge_tooltip:activate( screen )	
	self._hud._game.boardRig:getUnitRig( self._targetUnitID )._prop:setRenderFilter( { shader=KLEIAnim.SHADER_HILITE,r=255/255,g= 255/255,b= 0/255,	a=0.8,	lum=1.0-0.41 } )
	local sim = self._hud._game.simCore
	local range = 1
	local coords = {}
	local targetUnit = sim:getUnit( self._targetUnitID )
	local x0, y0 = targetUnit:getLocation()
	local targetCell = sim:getCell( x0, y0 )
	local cells = {targetCell}
	coords = simquery.rasterCircle( sim, x0, y0, range )
	for i=1,#coords-1,2 do
		local cell = sim:getCell(coords[i],coords[i+1])
		if cell then
		local raycastX, raycastY = sim:getLOS():raycast(x0, y0, cell.x, cell.y)			
			if raycastX == cell.x and raycastY == cell.y then
				table.insert(cells, cell)
			end			
		end
	end
	self._hiliteID = self._hud._game.boardRig:hiliteCells( cells, { 155/255, 155/255, 0/255, 0.08 } )	

	for i, x, y in util.xypairs( cells ) do
        	local cell = sim:getCell( x, y )
                if cell then
                    	for _, cellUnit in ipairs(cell.units) do
                        	if cellUnit ~= targetUnit and (simquery.isAgent(cellUnit) or cellUnit:getTraits().mainframe_status) then					
					self._hud._game.boardRig:getUnitRig( cellUnit:getID() ):getProp():setRenderFilter( { shader=KLEIAnim.SHADER_HILITE,r=65/255,g= 255/255,	b= 65/255,a=0.8, lum = 0.1 } )
				end
                	end
       		end
       	end
				
end

function discharge_tooltip:deactivate()
	self._hud._game.boardRig:getUnitRig( self._targetUnitID )._prop:setRenderFilter( nil )
	self._hud._game.boardRig:unhiliteCells( self._hiliteID )
	self._hiliteID = nil

	local sim = self._hud._game.simCore
	local coords = {}
	local range = 1
	local targetUnit = sim:getUnit( self._targetUnitID )
	local x0, y0 = targetUnit:getLocation()
	local targetCell = sim:getCell( x0, y0 )
	local cells = {targetCell}
	coords = simquery.rasterCircle( sim, x0, y0, range )
	for i=1,#coords-1,2 do
		local cell = sim:getCell(coords[i],coords[i+1])
		if cell then
		local raycastX, raycastY = sim:getLOS():raycast(x0, y0, cell.x, cell.y)			
			if raycastX == cell.x and raycastY == cell.y then
				table.insert(cells, cell)
			end			
		end
	end
	for i, x, y in util.xypairs( cells ) do
        	local cell = sim:getCell( x, y )
                if cell then
                    	for _, cellUnit in ipairs(cell.units) do
                        	if cellUnit ~= targetUnit and simquery.isAgent(cellUnit) or cellUnit:getTraits().mainframe_status then					
					self._hud._game.boardRig:getUnitRig( cellUnit:getID() ):refreshRenderFilter()
				end
                	end
       		end
       	end

end


local wireless_overload =
{
	name = STRINGS.AMRE.ABILITIES.DISCHARGE,
	profile_icon = "gui/icons/action_icons/Action_icon_Small/icon-item_hijack_small.png",
 	proxy = true,
	usesAction = true,	

	baseDamage = 1,
	targetDamage = 5,
	range = 1,
			
	getName = function( self, sim, unit )
		return STRINGS.ABILITIES.ICEBREAK
	end,

	getProfileIcon = function( self, sim, abilityOwner )
        	return abilityOwner:getUnitData().overload_icon or self.overload_icon
    	end,
	

	onTooltip = function( self, hud, sim, abilityOwner, abilityUser, targetUnit )
		if targetUnit == nil then
			return
		end
		return discharge_tooltip( hud, abilityOwner, abilityUser, targetUnit )
	end,



	acquireTargets = function( self, targets, game, sim, unit )
		if not self:canUseAbility( sim, unit ) then
			return --nil
		end			
		local userUnit = unit:getUnitOwner()	
        	assert( userUnit, tostring(unit and unit:getName())..", "..tostring(unit:getLocation()) )
		local cell = sim:getCell( userUnit:getLocation() )
        	local cells = { cell }

		for dir, exit in pairs(cell.exits) do
            		if simquery.isOpenExit( exit ) then
                		table.insert( cells, exit.cell )
            		end
        	end

		local ability_range = 12
		if unit:getTraits().range then
			ability_range = unit:getTraits().range
		end

		local units = {}
		local x0, y0 = userUnit:getLocation()

		for _, targetUnit in pairs(sim:getAllUnits()) do
			-- or targetUnit:getTraits().mainframe_console
			if (targetUnit:getTraits().mainframe_ice or targetUnit:getTraits().deployed) and targetUnit:getPlayerOwner() == sim:getPC() and targetUnit:getTraits().mainframe_status ~= "off" then

				local x1,y1 = targetUnit:getLocation()
				local distance =  mathutil.dist2d( x0, y0, x1, y1 )
				if sim:canUnitSeeUnit( userUnit, targetUnit ) and distance <= ability_range then
					table.insert( units, targetUnit )
				end
				
			end
		end 		
		return targets.unitTarget( game, units, self, unit, userUnit )
	end,

			
	canUseAbility = function( self, sim, unit )
		-- Must have a user owner.
		local userUnit = unit:getUnitOwner()
		if not userUnit then
			return false
		end
		if unit:getTraits().cooldown and unit:getTraits().cooldown > 0 then
			return false, nil --util.sformat(STRINGS.UI.REASON.COOLDOWN,unit:getTraits().cooldown)
		end
		if unit:getTraits().usesCharges and unit:getTraits().charges < 1 then
			return false, nil --util.sformat(STRINGS.UI.REASON.CHARGES)
		end
		if userUnit:getAP() < 1 then 
			return false, nil --STRINGS.UI.REASON.ATTACK_USED
		end
		
        return abilityutil.checkRequirements( unit, userUnit)
	end,
		
	executeAbility = function( self, sim, unit, userUnit, target )
		local mainframe = include( "sim/mainframe" )
		local userUnit = unit:getUnitOwner()
		local target = sim:getUnit(target)								
		local x0,y0 = userUnit:getLocation()
		local x1,y1 = target:getLocation()
		local targetCell = sim:getCell( x1, y1 )
		local cells = {targetCell}
		local baseDamage = self.baseDamage
		local targetDamage = self.targetDamage
		local range = self.range

		local oldFacing = userUnit:getFacing()
  		local newFacing = simquery.getDirectionFromDelta(x1-x0,y1-y0) 
		local pinning, pinnee = simquery.isUnitPinning(unit:getSim(), userUnit)
		
		if pinning and pinnee == target then
			newFacing = pinnee:getFacing()
		else
			pinning = false
		end

		simquery.suggestAgentFacing(unit, newFacing)
		--sim:dispatchEvent( simdefs.EV_UNIT_START_SHOOTING, { unitID = unit:getID(), newFacing=newFacing, oldFacing=oldFacing, targetUnitID = target:getID(), pinning=pinning } )

	    	if userUnit:getTraits().monster_hacking then 
			userUnit:getTraits().monster_hacking = false
		    userUnit:getSounds().spot = nil
		end
        						
		if userUnit:getTraits().data_hacking then 
			userUnit:stopHacking(sim)
	    	end				
		
		coords = simquery.rasterCircle( sim, x1, y1, range )
		for i=1,#coords-1,2 do
			local cell = sim:getCell(coords[i],coords[i+1])
			if cell then
			local raycastX, raycastY = sim:getLOS():raycast(x0, y0, cell.x, cell.y)			
				if raycastX == cell.x and raycastY == cell.y then
					table.insert(cells, cell)
				end			
			end
		end

		sim:startTrackerQueue(true)				
		sim:startDaemonQueue()			
		sim:emitSound( { path = "SpySociety/Actions/mainframe_noisemaker", range = 4, ignoreSight = true  }, x1, y1, target )
		sim:dispatchEvent( simdefs.EV_OVERLOAD_VIZ, {x = x1, y = y1, units = nil, range = range } )
		
		--if target:getTraits().mainframe_camera then
		--		target:killUnit(sim)
		--	else
				 
		--if not target:getTraits().mainframe_console then
		--		 mainframe.revertIce( sim, target )
		--end
		
		sim:dispatchEvent( simdefs.EV_KO_GROUP, true )		
	
		for i, x, y in util.xypairs( cells ) do
        		local cell = sim:getCell( x, y )
                	if cell then
                    		for _, cellUnit in ipairs(cell.units) do
                        		if simquery.isAgent(cellUnit) and not cellUnit:getTraits().isDrone then
						local damage = cellUnit:processKOresist( baseDamage )							   			
						cellUnit:setKO(sim, damage)				
					end	
                		end
				for i, cellUnit in ipairs( cell.units ) do
					if cellUnit ~= target and cellUnit:getTraits().mainframe_status then
						cellUnit:processEMP( baseDamage, true )
						if cellUnit:getTraits().deployed then 
							if cellUnit:getTraits().laptop then 
							--	cellUnit:waitForAnim("close")
								cellUnit:getTraits().deployed = nil
							else
								cellUnit:deactivate( sim )
							end							
						end
						sim:dispatchEvent( simdefs.EV_UNIT_REFRESH, { unit = cellUnit } )
					end				
				end
       			end
       		end
		if target:getTraits().deployed then 
			if target:getTraits().cooldown then 
				target:getTraits().cooldown = targetDamage
			end			
			if target:getTraits().laptop then 
			--	target:waitForAnim("close")
				target:getTraits().deployed = nil
			else
				target:deactivate( sim )
			end			
		else target:processEMP( targetDamage, true )
		end

		sim:dispatchEvent( simdefs.EV_UNIT_REFRESH, { unit = target } )

		sim:dispatchEvent( simdefs.EV_KO_GROUP, false )
		sim:startTrackerQueue(false)				
		sim:processDaemonQueue()	
		
		sim:dispatchEvent( simdefs.EV_PLAY_SOUND, {sound= "SpySociety/Objects/computer_shutdown", x=x1,y=y1} )
	      	
		userUnit:useAP( sim )
		inventory.useItem( sim, userUnit, unit )
		
		if userUnit:isValid() then							
			sim:dispatchEvent( simdefs.EV_UNIT_REFRESH, { unit = userUnit  } )
		end
	end,
}

return wireless_overload